<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.4.1 of May 30, 2006 on May 22, 2008 at 11:16:14 am</time-stamp>
<!-- Changes from: PV-DM-Support(Kila.60,bbuxton)  to: PV-DM-Support(Kila.61,bbuxton) -->


<methods>
<class-id>PROVISO.PvElement</class-id> <category>property support</category>

<body package="PV-DM-Support" selector="addProperty:">addProperty: aProperty 
	
	| realProperty |
	aProperty
		origin: self origin;
		username: self dbSession username.
	aProperty metricId isNil 
		ifTrue: 
			[(realProperty := self propertyNamed: aProperty name) isNil 
				ifTrue: 
					[realProperty := aProperty.
					realProperty metricId: self nextFakePropertyId]
				ifFalse: 
					[aProperty metricId: realProperty metricId.
					self properties removeKey: realProperty metricId.
					realProperty resyncUpdateFrom: aProperty]]
		ifFalse: 
			[aProperty formula isNil 
				ifTrue: [realProperty := aProperty]
				ifFalse: 
					[(realProperty := self propertyNamed: aProperty formula fullName) isNil 
						ifTrue: [realProperty := aProperty]
						ifFalse: 
							[self properties removeKey: realProperty metricId.
							realProperty resyncUpdateFrom: aProperty].
					realProperty name: aProperty formula fullName]].
	self properties at: realProperty metricId put: realProperty</body>
</methods>


<class>
<name>PvProperty</name>
<environment>PROVISO</environment>
<super>PROVISO.PvDomainObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>resourceId metricId value date formula origin username </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Support</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvProperty</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="origin">origin
	^origin</body>

<body package="PV-DM-Support" selector="username">username
	^username</body>

<body package="PV-DM-Support" selector="origin:">origin: anObject
	origin := anObject</body>

<body package="PV-DM-Support" selector="username:">username: anObject
	username := anObject</body>
</methods>


<methods>
<class-id>PROVISO.PvProperty class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="initColumnMap">initColumnMap
	"PvProperty initColumnMap"

	columnMap := Dictionary withKeysAndValues: #(
		idx_metric metricId
		idx_resource resourceId
		dte_date date
		str_value value
		str_origin origin
		str_user username)</body>
</methods>


<methods>
<class-id>PROVISO.PvSubelement</class-id> <category>accessing properties</category>

<body package="PV-DM-Support" selector="addProperty:">addProperty: aProperty 
	
	| realProperty |
	aProperty
		origin: self origin;
		username: self dbSession username.
	aProperty metricId isNil 
		ifTrue: 
			[(realProperty := self propertyNamed: aProperty name) isNil 
				ifTrue: 
					[realProperty := aProperty.
					realProperty metricId: self nextFakePropertyId]
				ifFalse: 
					[aProperty metricId: realProperty metricId.
					self properties removeKey: realProperty metricId.
					realProperty resyncUpdateFrom: aProperty]]
		ifFalse: 
			[aProperty formula isNil 
				ifTrue: [realProperty := aProperty]
				ifFalse: 
					[(realProperty := self propertyNamed: aProperty formula fullName) isNil 
						ifTrue: [realProperty := aProperty]
						ifFalse: 
							[self properties removeKey: realProperty metricId.
							realProperty resyncUpdateFrom: aProperty].
					realProperty name: aProperty formula fullName]].
	self properties at: realProperty metricId put: realProperty</body>
</methods>


<methods>
<class-id>PROVISO.PvEvent</class-id> <category>updating</category>

<body package="PV-DM-Support" selector="addProperty:">addProperty: aProperty 
	aProperty
		origin: self origin;
		username: self dbSession username.
	self properties at: aProperty attributeId put: aProperty</body>
</methods>



</st-source>
